/*                              
 * Khepera Serial communicatin Library header
 * Author:  Pierre Bureau for K-Team SA
 * Version: 1.0
 * Date:    19.11.2002
 */

/*  This file is part of K6300 Image Grabber.
 *  (c) 2002 Pierre Bureau for K-Team SA <pbureau@k-team.com>
 *
 *  K6300 Image Grabber is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 *  K6300 Image Grabber is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with K6300 Image Grabber; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _SERIALINC
#define _SERIALINC

#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
//#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <sys/signal.h>
#include <sys/types.h>

#ifdef __WIN32
#include <basetyps.h>
#include <basetsd.h>
#include <windef.h>
#include <w32api.h>
#include <Windows.h>
#include <winbase.h>
#endif

int  kt_open_port(const char * device);
int  kt_set_serial(unsigned speed);
void kt_close_port();
int  kt_command(const char * cmd);
int  kt_send_str(const char * cmd,int len);
void kt_serial_flush();
int  kt_read_buffer(char * answer, unsigned  maxlen);
int  kt_read_wait(char * answer, unsigned  maxlen);
int  kt_read_line(char * answer, unsigned  maxlen);

#endif /*_SERIALINC*/
